
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>android 监听网络状态的变化及实战 / 憋错料</title>

    <meta name="description" content="android 监听网络状态的变化及实战 android 监听网络状态的变化及实际应用 转载请注明博客地址:http://blog.csdn.net/gdutxiaoxu/article/details/53008266 平时我们在请求错误的情况下,通常会进行处理一下,一般来说,主要分为两方面的错误 - 没有网络的错误 - 在有网络的情况下,我们客户端的错误或者服务器端的错误 今天这篇博客主要阐述以下问题 怎样监听网络状态的变化,包括是否打开WiFi,否打开数据网络,当前连接的网络是否可用 网络没有打开情况下的处理,如弹出对话框,跳转到">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">android 监听网络状态的变化及实战</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>android 监听网络状态的变化及实际应用</h1>
<p><strong><a href="http://blog.csdn.net/gdutxiaoxu/article/details/53008266" rel="external nofollow noreferrer">转载请注明博客地址：</a><a href="http://blog.csdn.net/gdutxiaoxu/article/details/53008266" rel="external nofollow noreferrer">http://blog.csdn.net/gdutxiaoxu/article/details/53008266</a></strong></p>
<p>平时我们在请求错误的情况下，通常会进行处理一下，一般来说，主要分为两方面的错误</p>
<p>-  没有网络的错误</p>
<p>-  在有网络的情况下，我们客户端的错误或者服务器端的错误</p>
<p><strong>今天这篇博客主要阐述以下问题</strong></p>
<ul>
<li>怎样监听网络状态的变化，包括是否打开WiFi，否打开数据网络，当前连接的网络是否可用</li>
<li>网络没有打开情况下的处理,如弹出对话框，跳转到 打开 WiFi设置的界面等</li>
<li>非WiFi情况下是否加载图片，是否播放视频等</li>
</ul>
<h2>实现思路</h2>
<p>在网络错误的情况下获取网络状态进行判断，这种方法是可行的，但你想过了没有，如果每次都要进行这样的判断，岂不是代码量很多？有人会说，那把代码封装到一个类不就好了吗？这样确实能减少代码量，但是每次都要主动去获取，这样是不是挺麻烦的。实际上，google 早就帮我们封装好了，在网络状态变化的情况下会发出广播，我们只需要监听广播就好了 。</p>
<h3>使用静态广播还是动态注册广播的方式好呢？</h3>
<p>如果你不太清楚的话，我只能说即 基础不扎实。我们的应用之所以要监听网络状态的 变化，主要是为了在错误的情况下方便进行处理，退出我们当前的应用之后当然不需要监听了，所以选择动态注册广播。</p>
<ul>
<li>动态注册：随着所在的Activity或者应用销毁 以后，不会受到该广播</li>
<li>静态注册：退出应用后，仍然能够收到相应的广播</li>
</ul>
<p>共同点：都需要在AndroidMainest清单文件里面注册</p>
<h2>通过广播监听网络状态的两种方法</h2>
<h3>静态注册</h3>
<pre><code>&lt;receiver android:name=".network.NetworkConnectChangedReceiver"&gt;
    &lt;intent-filter&gt;
        &lt;action android:name="android.NET.conn.CONNECTIVITY_CHANGE" /&gt;
        &lt;action android:name="android.Net.wifi.WIFI_STATE_CHANGED" /&gt;
        &lt;action android:name="android.net.wifi.STATE_CHANGE" /&gt;
    &lt;/intent-filter&gt;
&lt;/receiver&gt;

</code></pre>
<h3>动态注册</h3>
<p>第一步：在AndroidMainest文件里面注册</p>
<pre><code>&lt;receiver android:name=".network.NetworkConnectChangedReceiver"&gt;
        &lt;/receiver&gt;</code></pre>
<p>第二步：调用 Context registerReceiver(Receiver,IntentFilter) 进行注册</p>
<pre><code>IntentFilter filter = new IntentFilter();
filter.addAction("android.net.conn.CONNECTIVITY_CHANGE");
filter.addAction("android.net.wifi.WIFI_STATE_CHANGED");
filter.addAction("android.net.wifi.STATE_CHANGE");
registerReceiver(mNetworkChangeListener,filter);

</code></pre>
<h3>我们自定义的NetworkChangeListener广播</h3>
<pre><code>
/**
 * 网络改变监控广播
 * &lt;p&gt;
 * 监听网络的改变状态,只有在用户操作网络连接开关(wifi,mobile)的时候接受广播,
 * 然后对相应的界面进行相应的操作，并将 状态 保存在我们的APP里面
 * &lt;p&gt;
 * &lt;p&gt;
 * Created by xujun
 */
public class NetworkConnectChangedReceiver extends BroadcastReceiver {

    private static final String TAG = "xujun";
    public static final String TAG1 = "xxx";

    @Override
    public void onReceive(Context context, Intent intent) {
        // 这个监听wifi的打开与关闭，与wifi的连接无关
        if (WifiManager.WIFI_STATE_CHANGED_ACTION.equals(intent.getAction())) {
            int wifiState = intent.getIntExtra(WifiManager.EXTRA_WIFI_STATE, 0);
            Log.e(TAG1, "wifiState" + wifiState);
            switch (wifiState) {
                case WifiManager.WIFI_STATE_DISABLED:
                    APP.getInstance().setEnablaWifi(false);
                    break;
                case WifiManager.WIFI_STATE_DISABLING:

                    break;
                case WifiManager.WIFI_STATE_ENABLING:
                    break;
                case WifiManager.WIFI_STATE_ENABLED:
                    APP.getInstance().setEnablaWifi(true);
                    break;
                case WifiManager.WIFI_STATE_UNKNOWN:
                    break;
                default:
                    break;

            }
        }
        // 这个监听wifi的连接状态即是否连上了一个有效无线路由，当上边广播的状态是WifiManager
        // .WIFI_STATE_DISABLING，和WIFI_STATE_DISABLED的时候，根本不会接到这个广播。
        // 在上边广播接到广播是WifiManager.WIFI_STATE_ENABLED状态的同时也会接到这个广播，
        // 当然刚打开wifi肯定还没有连接到有效的无线
        if (WifiManager.NETWORK_STATE_CHANGED_ACTION.equals(intent.getAction())) {
            Parcelable parcelableExtra = intent
                    .getParcelableExtra(WifiManager.EXTRA_NETWORK_INFO);
            if (null != parcelableExtra) {
                NetworkInfo networkInfo = (NetworkInfo) parcelableExtra;
                State state = networkInfo.getState();
                boolean isConnected = state == State.CONNECTED;// 当然，这边可以更精确的确定状态
                Log.e(TAG1, "isConnected" + isConnected);
                if (isConnected) {
                    APP.getInstance().setWifi(true);
                } else {
                    APP.getInstance().setWifi(false);
                }
            }
        }
        // 这个监听网络连接的设置，包括wifi和移动数据的打开和关闭。.
        // 最好用的还是这个监听。wifi如果打开，关闭，以及连接上可用的连接都会接到监听。见log
        // 这个广播的最大弊端是比上边两个广播的反应要慢，如果只是要监听wifi，我觉得还是用上边两个配合比较合适
        if (ConnectivityManager.CONNECTIVITY_ACTION.equals(intent.getAction())) {
            ConnectivityManager manager = (ConnectivityManager) context
                    .getSystemService(Context.CONNECTIVITY_SERVICE);
            Log.i(TAG1, "CONNECTIVITY_ACTION");

            NetworkInfo activeNetwork = manager.getActiveNetworkInfo();
            if (activeNetwork != null) { // connected to the internet
                if (activeNetwork.isConnected()) {
                    if (activeNetwork.getType() == ConnectivityManager.TYPE_WIFI) {
                        // connected to wifi
                        APP.getInstance().setWifi(true);
                        Log.e(TAG, "当前WiFi连接可用 ");
                    } else if (activeNetwork.getType() == ConnectivityManager.TYPE_MOBILE) {
                        // connected to the mobile provider‘s data plan
                        APP.getInstance().setMobile(true);
                        Log.e(TAG, "当前移动网络连接可用 ");
                    }
                } else {
                    Log.e(TAG, "当前没有网络连接，请确保你已经打开网络 ");
                }

                Log.e(TAG1, "info.getTypeName()" + activeNetwork.getTypeName());
                Log.e(TAG1, "getSubtypeName()" + activeNetwork.getSubtypeName());
                Log.e(TAG1, "getState()" + activeNetwork.getState());
                Log.e(TAG1, "getDetailedState()"
                        + activeNetwork.getDetailedState().name());
                Log.e(TAG1, "getDetailedState()" + activeNetwork.getExtraInfo());
                Log.e(TAG1, "getType()" + activeNetwork.getType());
            } else {   // not connected to the internet
                Log.e(TAG, "当前没有网络连接，请确保你已经打开网络 ");
                APP.getInstance().setWifi(false);
                APP.getInstance().setMobile(false);
                APP.getInstance().setConnected(false);

            }

        }
    }

}
</code></pre>
<p>最后，别忘记添加一下权限</p>
<pre><code>&lt;uses-permission android:name="android.permission.INTERNET"/&gt;

 &lt;!--允许读取网络状态--&gt;
 &lt;uses-permission android:name="android.permission.ACCESS_NETWORK_STATE"&gt;&lt;/uses-permission&gt;
&lt;!--允许读取wifi网络状态--&gt;
 &lt;uses-permission android:name="android.permission.ACCESS_WIFI_STATE"/&gt;</code></pre>
<h3>思路解析</h3>
<p>从上面的代码中，我们可以知道我们将我们当前的网络状态保存在我们的 APP 里面，这样当网络状态变化的时候会自动去改变 APP 里面相应的状态量，我们进行网络处理的 时候只需要去获取 APP里面的状态量，便可以判断出是属于哪一种网络错误，是不是很方便呢。</p>
<p>至于广播的Action主要有三种类型：</p>
<p><strong>WifiManager.WIFI_STATE_CHANGED_ACTION</strong></p>
<p>这个监听wifi的打开与关闭，与wifi的连接无关</p>
<p><strong>WifiManager.NETWORK_STATE_CHANGED_ACTION：</strong></p>
<p>这个监听wifi的连接状态即是否连上了一个有效无线路由，当上边广播的状态是WifiManager.WIFI_STATE_DISABLING，和WIFI_STATE_DISABLED的时候，根本不会接到这个广播。</p>
<p>在上边广播接到广播是WifiManager.WIFI_STATE_ENABLED状态的同时也会接到这个广播，当然刚打开wifi肯定还没有连接到有效的无线</p>
<p><strong>ConnectivityManager.CONNECTIVITY_ACTION</strong></p>
<p>这个监听网络连接的设置，包括wifi和移动数据的打开和关闭。.</p>
<p>最好用的还是这个监听。wifi如果打开，关闭，以及连接上可用的连接都会接到监听。这个广播的最大弊端是比上边两个广播的反应要慢，如果只是要监听wifi，我觉得还是用上边两个配合比较合适。</p>
<p>至于这个ConnectivityManager，NetworkInfo是什么东西，别急，下面会大概介绍一下。</p>
<hr>
<h2>ConnectivityManager和NetworkInfo</h2>
<h3>ConnectivityManager主要用来干什么</h3>
<ul>
<li>Monitor network connections (Wi-Fi, GPRS, UMTS, etc.)  （用来处理网络连接 ，包括Wi-Fi, GPRS, UMTS等）</li>
<li>Send broadcast intents when network connectivity changes（用 网络状态发生变化的时候发出 广播 ）</li>
<li>Attempt to “fail over” to another network when connectivity to a network is lost（但断开网络连接的时候，尝试去；连接另外一个网络</li>
<li>Provide an API that allows applications to query the coarse-grained or fine-grained state of the available networks（</li>
<li>Provide an API that allows applications to request and select networks for their data traffic</li>
</ul>
<h3>怎样获取ConnectivityManager对象呢？</h3>
<pre><code>ConnectivityManager cm = (ConnectivityManager) context.getSystemService(Context
        .CONNECTIVITY_SERVICE);</code></pre>
<h3>获取 NetworkInfo对象</h3>
<p>主要有一下 几种方法</p>
<ul>
<li>getNetworkInfo(int networkType)，但是这个方法已经过时，官网的解释如下：This method was deprecated in API level 23. This method does not support multiple connected networks of the same type. Use getAllNetworks() and getNetworkInfo(android.net.Network) instead.</li>
<li>getNetworkInfo(Network network)</li>
<li>getActiveNetwork()
<p>Returns a Network object corresponding to the currently active default data network.</li>
<li>getActiveNetworkInfo()，Returns details about the currently active default data network.</li>
<li>getAllNetworkInfo()这个方法已经过时，Use getAllNetworks() and getNetworkInfo(android.net.Network) instead.</li>
</ul>
<p><strong>综上所述，我们如果要知道当前Mobile网络或者WiFi网络是否已经连接上，总共有两种方法。</strong></p>
<p>第一种方法，只不过在 API23的时候已经 过时了</p>
<pre><code>
State wifiState = null;
State mobileState = null;

ConnectivityManager cm = (ConnectivityManager) context.getSystemService(Context
        .CONNECTIVITY_SERVICE);
wifiState = cm.getNetworkInfo(ConnectivityManager.TYPE_WIFI).getState();
mobileState = cm.getNetworkInfo(ConnectivityManager.TYPE_MOBILE).getState();

Log.d(TAG1,
        "wifi状态:" + wifiState + "\n mobile状态:" + mobileState);

if (wifiState != null &amp;&amp; mobileState != null
        &amp;&amp; State.CONNECTED != wifiState
        &amp;&amp; State.CONNECTED == mobileState) {// 手机网络连接成功
    Log.d(TAG1, "手机2g/3g/4g网络连接成功");

    APP.getInstance().setMobile(true);
    APP.getInstance().setWifi(false);
    APP.getInstance().setConnected(true);

} else if (wifiState != null &amp;&amp; State.CONNECTED == wifiState) {// 无线网络连接成功
    Log.d(TAG1, "无线网络连接成功");

    APP.getInstance().setMobile(false);
    APP.getInstance().setWifi(true);
    APP.getInstance().setConnected(true);

} else if (wifiState != null &amp;&amp; mobileState != null
        &amp;&amp; State.CONNECTED != wifiState
        &amp;&amp; State.CONNECTED != mobileState) {// 手机没有任何的网络
    Log.d(TAG1, "手机没有任何的网络");

    APP.getInstance().setMobile(false);
    APP.getInstance().setWifi(false);
    APP.getInstance().setConnected(false);

}

</code></pre>
<p>第二种方法</p>
<pre><code>ConnectivityManager manager = (ConnectivityManager) context
        .getSystemService(Context.CONNECTIVITY_SERVICE);
Log.i(TAG1, "CONNECTIVITY_ACTION");

NetworkInfo activeNetwork = manager.getActiveNetworkInfo();
if (activeNetwork != null) { // connected to the internet
    if (activeNetwork.isConnected()) {
        if (activeNetwork.getType() == ConnectivityManager.TYPE_WIFI) {
            // connected to wifi
            APP.getInstance().setWifi(true);
            Log.e(TAG, "当前WiFi连接可用 ");
        } else if (activeNetwork.getType() == ConnectivityManager.TYPE_MOBILE) {
            // connected to the mobile provider‘s data plan
            APP.getInstance().setMobile(true);
            Log.e(TAG, "当前移动网络连接可用 ");
        }
    } else {
        Log.e(TAG, "当前没有网络连接，请确保你已经打开网络 ");
    }
} else {   // not connected to the internet
    Log.e(TAG, "当前没有网络连接，请确保你已经打开网络 ");
    APP.getInstance().setWifi(false);
    APP.getInstance().setMobile(false);
    APP.getInstance().setConnected(false);

}
</code></pre>
<hr>
<h2>网络错误情况的处理</h2>
<p>正如前面所提到的，这篇博客吧网络错误主要分为两大类</p>
<p>-  没有网络情况的错误</p>
<p>-  在有网络的情况下，我们客户端的错误或者服务器端的错误</p>
<p>在这里 我们主要处理没有网络情况下的错误，现在 个人了解到 的主要有两种处理方法。</p>
<p>第一种做法：</p>
<p>在APP启动的 时候检查当前是否已经连接上网络，弹出一个对话框没有的话跳转到设置界面或者WiFi设置界面或者打开移动网络界面 。</p>
<p>第二种方法</p>
<p>其实跟第一种做法差不多，只是在每一次 错误的情况下，都会判断当前有没有 网络 ，没有弹出一个对话框，跳转到设置界面或者WiFi设置界面或者打开移动网络界面 ， 下面我们我们一起来看一下 怎样弹出一个对话框，并且跳转到相应的设置界面</p>
<p>这里我们采取第一种做法，效果图如下</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3czLnNpbmFpbWcuY24vbXc2OTAvOWZlNGFmYTBndzFmOWRwOG9xZmMyZzIwOHUwZ2poNnguZ2lm.jpg"></p>
<h3>代码如下</h3>
<pre><code>public static void showWifiDlg(final Context context) {
    AlertDialog.Builder builder = new AlertDialog.Builder(context.getApplicationContext());
    if (mWifiDialog == null) {
        mWifiDialog = builder.setIcon(R.drawable.ic_launcher)         //
                .setTitle("wifi设置")            //
                .setMessage("当前无网络").setPositiveButton("设置", new DialogInterface
                        .OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        // 跳转到系统的网络设置界面
                        Intent intent = null;
                        // 先判断当前系统版本
                        if (android.os.Build.VERSION.SDK_INT &gt; 10) {  // 3.0以上
                            intent = new Intent(android.provider.Settings
                                    .ACTION_WIFI_SETTINGS);
                        } else {
                            intent = new Intent();
                            intent.setClassName("com.android.settings",
                                    Settings.ACTION_WIFI_SETTINGS);
                        }
                        if ((context instanceof Application)) {
                            intent.addFlags(FLAG_ACTIVITY_NEW_TASK);
                        }
                        context.startActivity(intent);

                    }
                }).setNegativeButton("知道了", null).create();
        // 设置为系统的Dialog，这样使用Application的时候不会 报错
        mWifiDialog.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);
    }
    mWifiDialog.show();

}
</code></pre>
<p>这里对几个 重要的 Action说一下</p>
<ul>
<li>ACTION_DATA_ROAMING_SETTINGS ： 跳转到移动网络设置界面</li>
<li>ACTION_WIFI_SETTINGS
<p>Activity Action: Show settings to allow configuration of Wi-Fi.</li>
<li>ACTION_WIRELESS_SETTINGS
<p>Activity Action: Show settings to allow configuration of wireless controls such as Wi-Fi, Bluetooth and Mobile networks.</li>
</ul>
<p>关于更多Activity Action，请参考<a href="https://developer.android.com/reference/android/provider/Settings.html" rel="external nofollow noreferrer">官网地址</a></p>
<p><strong>需要注意的是</strong></p>
<p>若我们 使用的Context不是Activity 的Context 而是Application的 Context，我们 需要做以下处理 ，否则会报错</p>
<pre><code>// 设置为系统级别的Dialog
mWifiDialog.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);

if ((context instanceof Application)) {                            intent.addFlags(FLAG_ACTIVITY_NEW_TASK);
 }
context.startActivity(intent);

在AndroidMainFest中添加以下权限 。
 &lt;!--允许 弹出系统级别的AlterDialog--&gt;
    &lt;uses-permission android:name="android.permission.SYSTEM_ALERT_WINDOW"/&gt;
</code></pre>
<hr>
<h2>智能无图</h2>
<p>智能无图，这种浏览模式我们平时 很常见，比如在UC浏览器中，网易新闻中都有看到这种模式，这种模式的实质就是监听网络状态，再根据是否是WiFi去确定是否加载网络图片。</p>
<h3>效果图如下</h3>
<p>我们可以看到在开启智能无图的情况下，若不是连接WiFi ，我们是不会去加载网络图片的。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3czLnNpbmFpbWcuY24vbXc2OTAvOWZlNGFmYTBndzFmOWRvaXY3cGw4ZzIwOW8wajFxdjUuZ2lm.jpg"></p>
<h3>实现的核心代码如下</h3>
<p>1）当智能无图模式变化的时候，我们会把标志存进SharePreferences中</p>
<pre><code>mSwitchWifiPic.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {

        SPUtils.put(SPConstants.isIntelligentNoPic,isChecked);

    }
});
</code></pre>
<p>同时我们为了进来的时候界面与SharePreferences中的 isIntelligentNoPic的值保持一致，我们需要调用一下代码</p>
<pre><code>boolean isIntelligentNoPic = SPUtils.getBoolean(SPConstants.isIntelligentNoPic);
mSwitchWifiPic.setChecked(isIntelligentNoPic);
</code></pre>
<p>2）在NewsListAdapter中</p>
<pre><code>// 是否开启智能无图模式，true表示开启智能无图模式
boolean isIntelligentNoPic = SPUtils.getBoolean(Constants.SPConstants.isIntelligentNoPic);
WriteLogUtil.i("isIntelligentNoPic=" + isIntelligentNoPic);
if (isIntelligentNoPic) {
    if (APP.getInstance().isWifi()) {
        GlideUtils.display(mContext, iv, picUrl);
    } else {
        iv.setImageDrawable(new ColorDrawable(Color.GRAY));
    }

} else {
    GlideUtils.display(mContext, iv, picUrl);
}
</code></pre>
<p>至于APP.getInstance().isWifi()表示当前是否连接WiFi，是通过 监听广播实现的 ，前面已经说明了，这里就不再阐述了。</p>
<hr>
<h2>拓展工具类</h2>
<p>以下工具类参考<a href="http://www.jianshu.com/p/10ed9ae02775" rel="external nofollow noreferrer">Android获取网络状态</a></p>
<pre><code>public class NetStateUtils {

    /**
     * 判断当前网络是否是移动网络
     *
     * @param context
     * @return boolean
     */
    public static boolean is3G(Context context) {
        ConnectivityManager connectivityManager = (ConnectivityManager) context
                .getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo activeNetInfo = connectivityManager.getActiveNetworkInfo();
        if (activeNetInfo != null
                &amp;&amp; activeNetInfo.getType() == ConnectivityManager.TYPE_MOBILE) {
            return true;
        }
        return false;
    }

    /**
     * 判断当前网络是否是wifi网络
     *
     * @param context
     * @return boolean
     */
    public static boolean isWifi(Context context) {
        ConnectivityManager connectivityManager = (ConnectivityManager) context
                .getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo activeNetInfo = connectivityManager.getActiveNetworkInfo();
        if (activeNetInfo != null
                &amp;&amp; activeNetInfo.getType() == ConnectivityManager.TYPE_WIFI) {
            return true;
        }
        return false;
    }

    /**
     * 判断当前网络是否是2G网络
     *
     * @param context
     * @return boolean
     */
    public static boolean is2G(Context context) {
        ConnectivityManager connectivityManager = (ConnectivityManager) context
                .getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo activeNetInfo = connectivityManager.getActiveNetworkInfo();
        if (activeNetInfo != null
                &amp;&amp; (activeNetInfo.getSubtype() == TelephonyManager.NETWORK_TYPE_EDGE
                || activeNetInfo.getSubtype() == TelephonyManager.NETWORK_TYPE_GPRS || activeNetInfo
                .getSubtype() == TelephonyManager.NETWORK_TYPE_CDMA)) {
            return true;
        }
        return false;
    }

    /**
     * wifi是否打开
     */
    public static boolean isWifiEnabled(Context context) {
        ConnectivityManager mgrConn = (ConnectivityManager) context
                .getSystemService(Context.CONNECTIVITY_SERVICE);
        TelephonyManager mgrTel = (TelephonyManager) context
                .getSystemService(Context.TELEPHONY_SERVICE);
        return ((mgrConn.getActiveNetworkInfo() != null &amp;&amp; mgrConn
                .getActiveNetworkInfo().getState() == NetworkInfo.State.CONNECTED) || mgrTel
                .getNetworkType() == TelephonyManager.NETWORK_TYPE_UMTS);
    }

    /**
     * 判断是否有网络连接
     *
     * @param context
     * @return
     */
    public static boolean isNetworkConnected(Context context) {
        if (context != null) {
            // 获取手机所有连接管理对象(包括对wi-fi,net等连接的管理)
            ConnectivityManager manager = (ConnectivityManager) context.getSystemService(Context
                    .CONNECTIVITY_SERVICE);
            // 获取NetworkInfo对象
            NetworkInfo networkInfo = manager.getActiveNetworkInfo();
            //判断NetworkInfo对象是否为空
            if (networkInfo != null)
                return networkInfo.isAvailable();
        }
        return false;
    }

    /**
     * 判断MOBILE网络是否可用
     *
     * @param context
     * @param context
     * @return
     */
    public static boolean isMobileConnected(Context context) {
        if (context != null) {
            //获取手机所有连接管理对象(包括对wi-fi,net等连接的管理)
            ConnectivityManager manager = (ConnectivityManager) context.getSystemService(Context
                    .CONNECTIVITY_SERVICE);
            //获取NetworkInfo对象
            NetworkInfo networkInfo = manager.getActiveNetworkInfo();
            //判断NetworkInfo对象是否为空 并且类型是否为MOBILE
            if (networkInfo != null &amp;&amp; networkInfo.getType() == ConnectivityManager.TYPE_MOBILE)
                return networkInfo.isAvailable();
        }
        return false;
    }

    /**
     * 获取当前网络连接的类型信息
     * 原生
     *
     * @param context
     * @return
     */
    public static int getConnectedType(Context context) {
        if (context != null) {
            //获取手机所有连接管理对象
            ConnectivityManager manager = (ConnectivityManager) context.getSystemService(Context
                    .CONNECTIVITY_SERVICE);
            //获取NetworkInfo对象
            NetworkInfo networkInfo = manager.getActiveNetworkInfo();
            if (networkInfo != null &amp;&amp; networkInfo.isAvailable()) {
                //返回NetworkInfo的类型
                return networkInfo.getType();
            }
        }
        return -1;
    }

    /**
     * 获取当前的网络状态 ：没有网络-0：WIFI网络1：4G网络-4：3G网络-3：2G网络-2
     * 自定义
     *
     * @param context
     * @return
     */
    public static int getAPNType(Context context) {
        //结果返回值
        int netType = 0;
        //获取手机所有连接管理对象
        ConnectivityManager manager = (ConnectivityManager) context.getSystemService(Context
                .CONNECTIVITY_SERVICE);
        //获取NetworkInfo对象
        NetworkInfo networkInfo = manager.getActiveNetworkInfo();
        //NetworkInfo对象为空 则代表没有网络
        if (networkInfo == null) {
            return netType;
        }
        //否则 NetworkInfo对象不为空 则获取该networkInfo的类型
        int nType = networkInfo.getType();
        if (nType == ConnectivityManager.TYPE_WIFI) {
            //WIFI
            netType = 1;
        } else if (nType == ConnectivityManager.TYPE_MOBILE) {
            int nSubType = networkInfo.getSubtype();
            TelephonyManager telephonyManager = (TelephonyManager) context.getSystemService
                    (Context.TELEPHONY_SERVICE);
            //3G   联通的3G为UMTS或HSDPA 电信的3G为EVDO
            if (nSubType == TelephonyManager.NETWORK_TYPE_LTE
                    &amp;&amp; !telephonyManager.isNetworkRoaming()) {
                netType = 4;
            } else if (nSubType == TelephonyManager.NETWORK_TYPE_UMTS
                    || nSubType == TelephonyManager.NETWORK_TYPE_HSDPA
                    || nSubType == TelephonyManager.NETWORK_TYPE_EVDO_0
                    &amp;&amp; !telephonyManager.isNetworkRoaming()) {
                netType = 3;
                //2G 移动和联通的2G为GPRS或EGDE，电信的2G为CDMA
            } else if (nSubType == TelephonyManager.NETWORK_TYPE_GPRS
                    || nSubType == TelephonyManager.NETWORK_TYPE_EDGE
                    || nSubType == TelephonyManager.NETWORK_TYPE_CDMA
                    &amp;&amp; !telephonyManager.isNetworkRoaming()) {
                netType = 2;
            } else {
                netType = 2;
            }
        }
        return netType;
    }

    /**
     * 判断GPS是否打开
     * ACCESS_FINE_LOCATION权限
     *
     * @param context
     * @return
     */
    public static boolean isGPSEnabled(Context context) {
        //获取手机所有连接LOCATION_SERVICE对象
        LocationManager locationManager = ((LocationManager) context.getSystemService(Context
                .LOCATION_SERVICE));
        return locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER);
    }

    /**
     * 获得本机ip地址
     *
     * @return
     */
    public static String GetHostIp() {
        try {
            for (Enumeration&lt;NetworkInterface&gt; en = NetworkInterface
                    .getNetworkInterfaces(); en.hasMoreElements(); ) {
                NetworkInterface intf = en.nextElement();
                for (Enumeration&lt;InetAddress&gt; ipAddr = intf.getInetAddresses(); ipAddr
                        .hasMoreElements(); ) {
                    InetAddress inetAddress = ipAddr.nextElement();
                    if (!inetAddress.isLoopbackAddress()) {
                        return inetAddress.getHostAddress();
                    }
                }
            }
        } catch (SocketException ex) {
        } catch (Exception e) {
        }
        return null;
    }

    /**
     * 获取本机串号imei
     *
     * @param context
     * @return
     */
    public static String getIMEI(Context context) {
        TelephonyManager telephonyManager = (TelephonyManager) context
                .getSystemService(Context.TELEPHONY_SERVICE);
        return telephonyManager.getDeviceId();
    }

    /***
     * 判断是否有外网连接（普通方法不能判断外网的网络是否连接，比如连接上局域网）
     *
     * @return
     */

    public static final boolean ping() {

        String result = null;
        try {
            String ip = "www.baidu.com";// ping 的地址，可以换成任何一种可靠的外网
            Process p = Runtime.getRuntime().exec("ping -c 3 -w 100 " + ip);// ping网址3次
            // 读取ping的内容，可以不加
            InputStream input = p.getInputStream();
            BufferedReader in = new BufferedReader(new InputStreamReader(input));
            StringBuffer stringBuffer = new StringBuffer();
            String content = "";
            while ((content = in.readLine()) != null) {
                stringBuffer.append(content);
            }
            Log.d("------ping-----", "result content : " + stringBuffer.toString());
            // ping的状态
            int status = p.waitFor();
            if (status == 0) {
                result = "success";
                return true;
            } else {
                result = "failed";
            }
        } catch (IOException e) {
            result = "IOException";
        } catch (InterruptedException e) {
            result = "InterruptedException";
        } finally {
            Log.d("----result---", "result = " + result);
        }
        return false;

    }
}
</code></pre>
<hr>
<br /><strong><a href="http://blog.csdn.net/gdutxiaoxu/article/details/53008266" rel="external nofollow noreferrer">转载请注明博客地址：</a><a href="http://blog.csdn.net/gdutxiaoxu/article/details/53008266" rel="external nofollow noreferrer">http://blog.csdn.net/gdutxiaoxu/article/details/53008266</a></strong></p>
<p><strong><a href="https://github.com/gdutxiaoxu/FunAPP.git" rel="external nofollow noreferrer">源码下载地址：</a><a href="https://github.com/gdutxiaoxu/FunAPP.git" rel="external nofollow noreferrer">https://github.com/gdutxiaoxu/FunAPP.git</a></strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 03:43:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/his/" title="his">his</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/asc/" title="asc">asc</a>, <a href="https://www.biecuoliao.com/tag/string/" title="string">string</a>, <a href="https://www.biecuoliao.com/tag/method/" title="method">method</a>, <a href="https://www.biecuoliao.com/tag/ret/" title="ret">ret</a>, <a href="https://www.biecuoliao.com/tag/dial/" title="dial">dial</a>, <a href="https://www.biecuoliao.com/tag/extra/" title="extra">extra</a>, <a href="https://www.biecuoliao.com/tag/intern/" title="intern">intern</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>android 监听网络状态的变化及实战的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nLRKx4.html" rel="bookmark">Android监听网络状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				该笔记是用来实时获取网络的状态,有点想QQ的断网提醒,为了以后的工作中用到,就在此处写下关于此判断的代码,下面就是写的一些代码: package com.example.nettest; import receiver.NetReceiver; import android.app.Activity; import android.content.IntentFilter; import android.net.ConnectivityManager; import android.os.Bun			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Z1zOg0.html" rel="bookmark">Android实时监听网络状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在开发android应用时,涉及到要进行网络访问,时常需要进行网络状态的检查,以提供给用户必要的提醒.一般可以通过ConnectivityManager来完成该工作. ConnectivityManager有四个主要任务: 1.监听手机网络状态(包括GPRS,WIFI, UMTS等) 2.手机状态发生改变时,发送广播 3.当一个网络连接失败时进行故障切换 4.为应用程序提供可以获取可用网络的高精度和粗糙的状态 当我们要在程序中监听网络状态时,只要一下几个步骤即可:  1.处理Recevier接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OkZWG3.html" rel="bookmark">监听网络状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网络监听的自己写过一个,刚在github上找到一个,先保存着,以后直接用 原文地址:https://github.com/GHdeng/NetMonitor 使用广播监听网络变化 ###需求确认 监听当前网络的状态和类型 类似京东客户端,当网络发生变化时相应更新UI界面 ###制作流程 使用广播监听当前网络的状态. 配合Application周期注册监听,使得每个界面都继续监听 抽出BaseActivity类实现回调 #####1.继承BroadcastReceiver实现onReceive方法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyqpymM.html" rel="bookmark">android监听SIM状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/* 监听sim状态改变的广播,返回sim卡的状态, 有效或者无效. 双卡中只要有一张卡的状态有效即返回状态为有效,两张卡都无效则返回无效. */ import android.app.Service; import android.content.BroadcastReceiver; import android.content.Context; import android.content.Intent; import android.telephony.TelephonyManager;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xX8aj0.html" rel="bookmark">Android使用BroadcastReceiver监听网络状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在开发中,经常会遇到需要判断手机网络状态从而进行各种操作的功能,在这里简单介绍下这种功能的实现. 如题,通过BroadcastReceiver我们能在网络状态改变的时候监听到它. 那么,注册广播的两种方式: 1.静态注册:在AndroidManifest.xml中用标签声明注册,并在标签内用标签设置过滤器. 1 2 3 4 5 6 7 &lt;!--继承BroadcastReceiver,重写onReceiver方法--&gt; &lt;receiver android:name=&quot;MyRece			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6e9ad4.html" rel="bookmark">Android 监听网络变化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
							</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLJzPe3.html" rel="bookmark">Android开发之使用广播监听网络状态变化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们经常需要判断网络状态的变化,如有无网络,所以需要监听网络状态的变化,比如网络断开,网络连接给予友好提示.如何监听网络状态的变化呢,最近工作中需要用到这个,于是就用广播机制来实现了网络状态的监听. 使用广播机制来监听网络状态主要涉及到以下几点: 1.需要自己编写个网络广播接收器,该接收器继承BroadcastReceiver类,用来接收系统发出的广播.比如我自己写了个NetStatusReceiver广播接收器.代码如下: package com.log.system; import andr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wjRr10.html" rel="bookmark">Android实践--监測网络状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android 监測网络状态 我们在使用Android手机时候,一些APP须要网络环境才干执行,所以手机须要可用的网络,无论是2G.3G或者WIFI.甚至有一些比較耗流量的APP仅仅能在WIFI的环境下执行,或者提供用户自行选择是否仅仅能在WIFI环境下执行,作为用户貌似后者体验更好.那么作为开发人员,我们仅仅须要几步就能给用户这样的体验. ------------------------------------------------------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47zgYo3.html" rel="bookmark">android-监听网络状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.注册一个广播接收器,监听网络状态private void Start() { IntentFilter filter = new IntentFilter(); filter.addAction(ConnectivityManager.CONNECTIVITY_ACTION); filter.addAction(WifiManager.WIFI_STATE_CHANGED_ACTION); filter.addAction(WifiManager.NETWORK_STATE_CHANGED_			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qdB70.html" rel="bookmark" class="title">试图解释下ERP</a>
					<div>
						ERP,字面的意思就是企业资源规划.但现在基本上是企业信息系统的统称,过去叫MIS.我们就是有这个本事,不管什么高大上的事物,很快就会做的很烂. 你可以这样理解ERP. 现在来了个订单,你需要回答下面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPGWa4.html" rel="bookmark" class="title">DHCP底层参考</a>
					<div>
						[原创翻译,水平有限] ISC DHCP支持802.1的以太网帧,令牌环和FDDI等网络.为了桥接物理层和DHCP层,它还必须实现IP和UDP协议帧. 这源于UNIX BSD socket 对未配置接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8Dbz0.html" rel="bookmark" class="title">Linux Shell高级技巧</a>
					<div>
						Linux Shell高级技巧(一) http://www.cnblogs.com/stephen-liu74/archive/2011/12/22/2271167.html一.将输入信息转换为大写字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5XnaM.html" rel="bookmark" class="title">深入浅出MFC&lbrack;摘记&rsqb;</a>
					<div>
						1.Windows程序的运行本质:基于消息,事件驱动(Message Based,Event Driven).2.程序调用GetMessage API循环获取消息,程序的生命靠它来推动. MSG ms ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lrBno4.html" rel="bookmark" class="title">javascript获取对象直接量中的属性和属性值</a>
					<div>
						javascript获取对象直接量中的属性和属性值:所谓的对象直接量简单来说就是,由大括号包裹的键值对列表,例如: var antzone={ webName:&quot;蚂蚁部落&quot;, ad ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdKA8M.html" rel="bookmark" class="title">APU平台DirectX 12性能测试：超级大惊喜！</a>
					<div>
						转自:http://www.ithome.com/html/digi/129840.htm [size=1pc]微软将会在接下来的GDC 2015游戏开发者大会上公布DirectX 12规范,而前段时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGLdnM.html" rel="bookmark" class="title">sql 时间&lpar;datetime&rpar;计算</a>
					<div>
						SELECT *FROM sc_sowu_orderreturnWHERE STATUS = '0'AND submit_time &lt; DATE_ADD(now(), INTERVAL - 4  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d5m7e3.html" rel="bookmark" class="title">poj 3784（对顶堆）</a>
					<div>
						Running Median Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 1824   Accepted: 889 Des ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QAd9L4.html" rel="bookmark" class="title">JS学习笔记 -- 延时器，提示框的应用</a>
					<div>
						&lt;!DOCTYPE html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPD2GyM.html" rel="bookmark" class="title">spring IOC加载流程</a>
					<div>
						看了网上.书上很多对于spring IOC容器加载过程的分析.大多都只是粗略的讲一下加载流程.其实这样也不错,简单粗暴.清晰记得之前和一个前辈交流时他说的一句话:什么设计模式.设计框架都是扯淡,能实现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVzyZdM.html" rel="bookmark" class="title">多封装，少开放</a>
					<div>
						近日在修改了一下下cocos2d-x的引擎代码(为了自己的组件),发现有些类的访问形式比较怪异,明明有些接口是只有特定类及其内部函数才去访问,却不使用友元声明的形式进行数据访问--当然使用了普通非vi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPBjEM.html" rel="bookmark" class="title">经典冒泡排序</a>
					<div>
						import java.util.Scanner; /* * * ==================冒泡 排序 */ public class BubbleSort { public static  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WaEJ0.html" rel="bookmark" class="title">Web高级征程：《大型网站技术架构》读书笔记系列</a>
					<div>
						一.此书到底何方神圣? &lt;大型网站技术架构:核心原理与案例分析&gt;通过梳理大型网站技术发展历程,剖析大型网站技术架构模式,深入讲述大型互联网架构设计的核心原理,并通过一组典型网站技术架构设计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5kRb3.html" rel="bookmark" class="title">解决 Springboot Unable to build Hibernate SessionFactory &commat;Column命名不起作用</a>
					<div>
						问题: Springboot启动报错: Caused by: org.springframework.beans.factory.BeanCreationException: Error creati ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRYg94.html" rel="bookmark" class="title">固原得句</a>
					<div>
						固原得句 百二河山最上游,葱郁佳气满原州. 风去大漠孤烟直,天转平高落日流. 握手千山连北极,唱歌万井动高秋. 酒酣忘却身为客,再上城南百尺楼. 固原市位于宁夏回族自治区南部,东.南.西三面与甘肃毗邻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NyaPV3.html" rel="bookmark" class="title">Lync 项目经验-03-共存迁移-Lync 2013-TO-SFB 2015-完成</a>
					<div>
						2016年05月18日,撰写Lync 2013 升级 SFB 2015 v1.2.docx. 2016年07月18日,Skype for Business Server 2015-规划表-2016-0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRwoW3.html" rel="bookmark" class="title">抽奖及背景图片的透明度设置时连着转盘图片也跟着虚幻解决方法</a>
					<div>
						blackView.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.5];					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wbaG0.html" rel="bookmark" class="title">你应该关注的几个网站</a>
					<div>
						Android开发技术前线 : https://github.com/bboyfeiyu/android-tech-frontierAndroid源码设计模式解析 : https://github.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkDow3.html" rel="bookmark" class="title">python&lowbar;如何让类支持比较运算？</a>
					<div>
						案例: 有时我们希望自定义的类,实例间可以使用比较运算符进行比较,我们自定义比较的行为. 需求: 有一个矩形的类,我们希望比较两个矩形的实例时,比较的是他们的面积 如何解决这个问题? 在类中重新定义比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47z9Z13.html" rel="bookmark" class="title">为什么说Python是一门动态语言--Python的魅力</a>
					<div>
						动态语言的定义:动态编程语言是高级程序设计语言的一个类别,在计算机科学领域已被广泛应用.它是一类在运行时可以改变其结构的语言:例如新的函数.对象.甚至代码可以被引进,已有的函数可以被删除或是其他结构上 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.021 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
